// -------------------------------------------------------------------------------
// 
// 		cwCu		VXevOwb_t@C
// 
// 				Ver 3.19d
// 
// -------------------------------------------------------------------------------

#ifndef __DXSYSTEM_H__
#define __DXSYSTEM_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxBaseFunc.h"

#ifdef __WINDOWS__
#include "Windows/DxSystemWin.h"
#endif

#ifdef __ANDROID__
#include "Android/DxSystemAndroid.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxSystemiOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__




#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------


// \̒` --------------------------------------------------------------------

// VXef[^\
struct DXSYSTEMDATA
{
	int						DxLib_InitializeFlag ;				// cwCȕĂ邩tO
	int						DxLib_RunInitializeFlag ;			// cwCȕAtO

	int						NotWinFlag ;						// cwCũEChE֘A@\gpȂtO
	int						NotDrawFlag ;						// `@\gpȂtO
	int						NotSoundFlag ;						// TEh@\gpȂtO
	int						NotInputFlag ;						// ͏Ԏ擾@\gpȂtO

	int						EndRequestFlag ;					// INGXgtO
	int						ASyncLoadFlag ;						// 񓯊ǂݍ݃tO

	int						LastErrorCode ;						// ŌɔG[̃G[R[h( DX_ERRORCODE_WIN_24BIT_COLOR Ȃ )
	wchar_t					LastErrorMessage[ 4096 ] ;			// ŌɔG[̃G[bZ[W
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

extern DXSYSTEMDATA DxSysData ;

// ֐vg^Cv錾-----------------------------------------------------------

// EI֌W
extern	int			DxLib_SysInit( void ) ;													// DxSysData ֌W̏s
extern	int			DxLib_EndRequest( void ) ;												// INGXgs
extern	int			DxLib_GetEndRequest( void ) ;											// INGXg̏Ԃ擾

// G[֐
extern	int			DxLib_SetLastError(    int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ */, const wchar_t *ErrorMessage ) ;			// G[R[hEbZ[Wݒ肷

extern	int			DxLib_Error(           const wchar_t *ErrorStr ) ;				// CũG[s
extern	int			DxLib_ErrorUTF16LE(    const char    *ErrorStr ) ;				// CũG[s( UTF16LE )
extern	int			DxLib_FmtError(        const wchar_t *FormatString, ... ) ;		// tCũG[s
extern	int			DxLib_FmtErrorUTF16LE( const char    *FormatString, ... ) ;		// tCũG[s( UTF16LE )

// 񓯊ǂݍ݊֌W
extern	int			GetASyncLoadFlag( void ) ;												// 񓯊ǂݍ݂sǂ擾

// ˑ֐
extern	int			GetClipboardText_PF(					TCHAR   *DestBuffer ) ;						// Nbv{[hɊi[ĂeLXgf[^ǂݏo( DestBuffer:i[obt@̐擪AhX   ߂l  -1:Nbv{[hɃeLXgf[^  -1ȊO:Nbv{[hɊi[Ă镶f[^̃TCY( P:byte ) ) 
extern	int			GetClipboardText_WCHAR_T_PF(			wchar_t *DestBuffer ) ;						// Nbv{[hɊi[ĂeLXgf[^ǂݏo( DestBuffer:i[obt@̐擪AhX   ߂l  -1:Nbv{[hɃeLXgf[^  -1ȊO:Nbv{[hɊi[Ă镶f[^̃TCY( P:byte ) ) 
extern	int			SetClipboardText_WCHAR_T_PF(			const wchar_t *Text                    ) ;	// Nbv{[hɃeLXgf[^i[

// wchar_tŊ֐
extern	int			GetClipboardText_WCHAR_T(		    wchar_t *DestBuffer ) ;
extern	int			SetClipboardText_WCHAR_T(		    const wchar_t *Text ) ;
extern	int			SetClipboardTextWithStrLen_WCHAR_T( const wchar_t *Text, size_t TextLength ) ;

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // __DXSYSTEM_H__

